
function Skinner:AdvancedTradeSkillWindow()
	if not self.db.profile.TradeSkillUI then return end

	self:keepFontStrings(ATSWRankFrame)
	self:keepFontStrings(ATSWRankFrameBorder)
	self:glazeStatusBar(ATSWRankFrame, 0)
	self:skinScrollBar{obj=ATSWListScrollFrame}
	self:keepFontStrings(ATSWExpandButtonFrame)
	self:skinDropDown{obj=ATSWInvSlotDropDown}
	self:skinDropDown{obj=ATSWSubClassDropDown}
	self:skinScrollBar{obj=ATSWQueueScrollFrame}
	self:skinEditBox{obj=ATSWInputBox, regs={9}, noWidth=true}
	self:skinEditBox{obj=ATSWFilterBox, regs={9}}
	self:skinAllButtons{obj=ATSWFrame}
	self:addSkinFrame{obj=ATSWFrame, kfs=true, x1=14, y1=-11, x2=-32, y2=10}
	-- m/p buttons
	self:skinButton{obj=ATSWCollapseAllButton, mp=true}
	for i = 1, ATSW_TRADE_SKILLS_DISPLAYED do
		self:skinButton{obj=_G["ATSWSkill"..i], mp=true}
	end
	if self.db.profile.Buttons then
		-- hook to manage changes to button textures
		self:SecureHook("ATSWFrame_Update", function()
			for i = 1, ATSW_TRADE_SKILLS_DISPLAYED do
				self:checkTex(_G["ATSWSkill"..i])
			end
		end)
	end

	-- Reagent frame
	self:skinAllButtons{obj=ATSWReagentFrame}
	self:addSkinFrame{obj=ATSWReagentFrame, kfs=true, x1=14, y1=-13, x2=-34, y2=10}

	-- Options frame
	self:skinAllButtons{obj=ATSWOptionsFrame}
	self:addSkinFrame{obj=ATSWOptionsFrame}

	-- Continue frame
	self:skinAllButtons{obj=ATSWContinueFrame}
	self:addSkinFrame{obj=ATSWContinueFrame}

	-- Tooltips
	if self.db.profile.Tooltips.skin then
		if self.db.profile.Tooltips.style == 3 then ATSWTradeskillTooltip:SetBackdrop(self.Backdrop[1]) end
		self:SecureHookScript(ATSWTradeskillTooltip, "OnShow", function(this)
			self:skinTooltip(this)
		end)
	end

	-- Shopping List frame
	self:skinScrollBar{obj=ATSWSLScrollFrame}
	self:addSkinFrame{obj=ATSWShoppingListFrame, kfs=true, x1=16, y1=-2, x2=-30, y2=40}

	-- Recipe Sorting Editor frame
	self:skinScrollBar{obj=ATSWCSUListScrollFrame}
	self:skinScrollBar{obj=ATSWCSSListScrollFrame}
	self:skinEditBox(ATSWCSNewCategoryBox)
	self:skinAllButtons{obj=ATSWCSFrame}
	self:addSkinFrame{obj=ATSWCSFrame, kfs=true, x1=14, y1=-11, x2=-32, y2=10}
	-- m/p buttons
	for i = 1, 17 do
		self:skinButton{obj=_G["ATSWCSCSkill"..i.."SkillButton"], mp=true}
	end
	if self.db.profile.Buttons then
		-- hook to manage changes to button textures
		self:SecureHook("ATSWCS_UpdateSkillList", function()
			for i = 1, 17 do
				self:checkTex(_G["ATSWCSCSkill"..i.."SkillButton"])
			end
		end)
	end

-->>--	All Reagent List frame
	self:skinDropDown{obj=ATSWAllReagentListCharDropDown}
	self:skinAllButtons{obj=ATSWAllReagentListFrame}
	self:addSkinFrame{obj=ATSWAllReagentListFrame, kfs=true, x1=14, y1=-1, x2=-35}
-->>--	Scan Delay frame
	self:glazeStatusBar(ATSWScanDelayFrameBar, 0)
	self:skinAllButtons{obj=ATSWScanDelayFrame}
	self:addSkinFrame{obj=ATSWScanDelayFrame, kfs=true}--, x1=10, y1=-12, x2=-32, y2=71}

end
